/* Produce a sine wave on output 0 of a parallel port */


#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <asm/io.h>

#include <rtl_sched.h>
#include <math.h>
#include "common.h"




RT_TASK mytask;

void fun(int t) {
	int output;
	double sine;

	while (1) {
		sine = sin((double)(rt_get_time())/10000.0);
		output = (sine > 0) ? 1 : 0;
		outb(output, LPT_PORT);
		rt_task_wait();
	}
}


int init_module(void)
{
	RTIME now = rt_get_time();

	rt_fptask_init(&mytask, fun, 1, 3000, 4);

	rt_task_make_periodic(&mytask, now + 1000, 1000);
	return 0;
}


void cleanup_module(void)
{
	rt_task_delete(&mytask);
}
