#include "../include/rtl_sched.h"
#include <asm/system.h>

static int rtl_linux_saved_ts;

int is_set_TS(void)
{
	int current_TS;
	__asm__("movl %%cr0,%%eax;andl $8,%%eax;movl %%eax,%0" \
			:"=m" (current_TS)/*output*/ \
			: /* no inputs */ \
			:"ax");
	return current_TS;
}


void rtl_fpu_save (RT_TASK *current_t)
{
	if (rtl_is_linux_task(current_t)) {
		rtl_linux_saved_ts = is_set_TS();
		clts();
	}
	__asm__("fsave %0" : "=m" (current_t->fpu_regs));
}


void rtl_fpu_restore (RT_TASK *current_t) {
	clts (); /* just in case */
	__asm__("frstor %0" : "=m" (current_t->fpu_regs));
	if (rtl_is_linux_task(current_t) && rtl_linux_saved_ts) {
		stts();
	}
}


/*
static int rt_is_fpu_used ()
{
	for (t = rt_tasks; t; t = t->next) {
		if (t -> uses_fp) {
			return 1;
		}
	}
	return 0;
}
*/


void rtl_task_init_fpu (RT_TASK *t, RT_TASK *fpu_owner)
{
	int was_set_TS;
	/* we  must save/restore the fpu state*/
	if (fpu_owner) {
		if ((was_set_TS = is_set_TS())) clts();
		__asm__("fsave %0" : "=m" (fpu_owner -> fpu_regs));
		__asm__("finit");
		__asm__("fsave %0" : "=m" (t->fpu_regs));
		__asm__("frstor %0" : "=m" (fpu_owner -> fpu_regs));
		if (was_set_TS) {
			stts();
		}
	} else {
		clts ();
		__asm__("finit");
	}
	return ;
}


